-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt


local M = {}
local timer
local flush_node
local flush_node2
local flush_sound
local flush_amount
local toilet_end

local function init(jbeamData)
  flush_amount = 0
  electrics.values.legran_gambler8x8_toilet_flush = 0
  timer = 0
  toilet_end = false

  for k, node in pairs (v.data.nodes) do
	if node.name == "tsfshower" then flush_node = node.cid end
	if node.name == "tsf1rr" then flush_node2 = node.cid end
  end
end

local function reset()
  flush_amount = 0
  toilet_end = false
  electrics.values.legran_gambler8x8_toilet_flush = 0
  timer = 0
  obj:setVolumePitch(flush_sound, (0), 0)
  obj:cutSFX(flush_sound)
end

local function initSounds()
  flush_sound = obj:createSFXSource2("amb_river_crossing_01", "AudioDefaultLoop3D", "flush_sound", flush_node, 5) --node, volume
--"event:>Engine>Starter>v6diesel_2011_eng"
  obj:cutSFX(flush_sound)
end

local function updateGFX(dt) -- ms

  if timer > 1 then
    if electrics.values.legran_gambler8x8_toilet_flush == 0.1 then
      electrics.values.legran_gambler8x8_toilet_flush = 1
      timer = 3000
    end
  end

  if timer <= 400 then
if electrics.values.legran_gambler8x8_toilet_flush and electrics.values.legran_gambler8x8_toilet_flush > 0 then
  electrics.values.legran_gambler8x8_toilet_flush = electrics.values.legran_gambler8x8_toilet_flush + 0.03
end
end

if electrics.values.legran_gambler8x8_toilet_flush and electrics.values.legran_gambler8x8_toilet_flush > 0.8 then
  if flush_amount < 3 then
    if not toilet_end then
  obj:addParticleByNodesRelative(flush_node, flush_node2, 1, 50, 0.00000000000001, 2)
    end
  end
  timer = timer + 1
end
if timer == 1 then
  if flush_amount < 3 then
    if not toilet_end then
  obj:playSFX(flush_sound)
      if flush_amount == 1 then
        guihooks.message("WARNING: Toilet water low!", 5, "gambler8x8_toilet")
      end
    end
  flush_amount = flush_amount + 1
  obj:setVolumePitch(flush_sound, (0.8), 0.7)
  end
end

if timer > 400 then
  electrics.values.legran_gambler8x8_toilet_flush = electrics.values.legran_gambler8x8_toilet_flush - 0.035
  obj:cutSFX(flush_sound)
  obj:setVolumePitch(flush_sound, (0), 0)
end

if electrics.values.legran_gambler8x8_toilet_flush > 1 then
  electrics.values.legran_gambler8x8_toilet_flush = 1
end
if electrics.values.legran_gambler8x8_toilet_flush < 0 then
  electrics.values.legran_gambler8x8_toilet_flush = 0
end

if electrics.values.legran_gambler8x8_toilet_flush == 0 then
  timer = 0
end


if not toilet_end then
if flush_amount == 3 then
  obj:cutSFX(flush_sound)
  obj:setVolumePitch(flush_sound, (0), 0)
  guihooks.message("Out of water! :( Refill in water", 5, "gambler8x8_toilet")
  toilet_end = true
end
end

if obj:inWater(flush_node) then
  if flush_amount > 0 then
    guihooks.message("Toilet refilled! :)", 5, "gambler8x8_toilet")
    flush_amount = 0
    toilet_end = false
    obj:setVolumePitch(flush_sound, (0.8), 0.7)
  end
end



end








-- public interface
M.init    = reset
M.reset   = reset
M.updateGFX = updateGFX
M.initSounds = initSounds
M.init = init

return M
